diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 585899a05..2a8647a40 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -125,6 +125,8 @@ val run by tasks.registering(JavaExec::class) {
     }
 
     systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
+
+    println(allJvmArgs);
 }
 
 val buildJar by tasks.registering(ShadowJar::class) {
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 0496247ab..3813b09d7 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1168,13 +1168,18 @@ public class Minecraft
                         LOGGER.error("Exception occurred while taking panoramic screenshot!", e);
                     }
                 } else {
-                    this.hudIngame.addChatMessage(ScreenShot.saveScreenshot(getMinecraftDir(), this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels()));
+                    ScreenShot.saveScreenshot(this, getMinecraftDir(), this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
                 }
                 Debug.pop();
             }
         } else {
             this.isTakingScreenshot = false;
         }
+
+        final @Nullable String message = ScreenShot.tickScreenShot();
+        if (message != null) {
+            this.hudIngame.addChatMessage(message);
+        }
     }
 
     public void shutdown() {
@@ -2604,29 +2609,13 @@ public class Minecraft
         return SoundRepository.allKeys;
     }
 
-    public boolean isAmbientOcclusionEnabled() {
-        return GameSettings.AMBIENT_OCCLUSION.value;
-    }
-
-    public boolean isTreeShadingEnabled() {
-        return GameSettings.TREE_SHADOWS.value;
-    }
-
-    public boolean isDebugInfoEnabled() {
-        return GameSettings.SHOW_DEBUG_SCREEN.value;
-    }
-
     @Override
     public boolean isFullbrightEnabled() {
         return this.fullbright;
     }
 
     public boolean canRenderEntityLabel() {
-        return isDebugInfoEnabled() && this.thePlayer != null && this.thePlayer.getGamemode() == Gamemodes.CREATIVE;
-    }
-
-    public float getOutlineWidth() {
-        return GameSettings.BLOCK_OUTLINE_WIDTH.value;
+        return GameSettings.SHOW_DEBUG_SCREEN.value && this.thePlayer != null && this.thePlayer.getGamemode() == Gamemodes.CREATIVE;
     }
 
     public int getAutosaveTimer() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 7018b3aa5..0505bb983 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -338,7 +338,7 @@ public class ScreenPhotoMode extends Screen {
         if (!this.shouldScreenshot) {
             super.render(mx, my, partialTick);
         } else {
-            ScreenShot.saveScreenshot(Global.accessor.getMinecraftDir(), this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
+            ScreenShot.saveScreenshot(mc, Global.accessor.getMinecraftDir(), this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
             this.shouldScreenshot = false;
         }
         scroll(Mouse.getDWheel());
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index dffb4cdec..8ca37f5d6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -309,7 +309,7 @@ public class HudIngame extends Gui {
                     int blockZ = MathHelper.floor(this.mc.thePlayer.z);
 
                     drawDebugScreenLine("Season: " + seasonString);
-                    drawDebugScreenLine("Weather: " + weatherString + " (" + (this.mc.currentWorld.weatherManager.getWeatherDuration() / 20) + "s I: " + percentRound(this.mc.currentWorld.weatherManager.getWeatherIntensity()) + "% P: " + percentRound(this.mc.currentWorld.weatherManager.getWeatherPower()) + "%)");
+                    drawDebugScreenLine("Weather: " + weatherString + " (" + (this.mc.currentWorld.getWeatherManager().getWeatherDuration() / 20) + "s I: " + percentRound(this.mc.currentWorld.getWeatherManager().getWeatherIntensity()) + "% P: " + percentRound(this.mc.currentWorld.getWeatherManager().getWeatherPower()) + "%)");
                     drawDebugScreenLine("Biome: " + Registries.BIOMES.getKey(this.mc.currentWorld.getBlockBiome(blockX, blockY, blockZ)));
 
                     float temperature = (float) floor100(this.mc.currentWorld.getBlockTemperature(blockX, blockZ));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 273614ceb..8b83cc91c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -18,7 +18,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.ShadersRenderer;
-import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.shader.framebuffer.FrameBuffer;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Blocks;
@@ -37,10 +37,7 @@ import java.io.File;
 import java.nio.ByteBuffer;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
-import java.util.ArrayList;
-import java.util.Date;
-import java.util.List;
-import java.util.Locale;
+import java.util.*;
 
 import static org.lwjgl.opengl.GL41.GL_RGBA;
 import static org.lwjgl.opengl.GL41.GL_TEXTURE_2D;
@@ -470,8 +467,8 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
             File screenshotsDir = new File(this.mc.getMinecraftDir(), "screenshots");
             //noinspection ResultOfMethodCallIgnored
             screenshotsDir.mkdir();
-            Texture texture = ((ShadersRenderer) this.mc.renderer).getWorldFramebufferColor();
-            texture.bind();
+            final @NotNull FrameBuffer frameBuffer = Objects.requireNonNull(((ShadersRenderer) this.mc.renderer).getWorldFrameBuffer());
+            Objects.requireNonNull(frameBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
 
             int w = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
             int h = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
@@ -502,8 +499,8 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
     public void specificScreenshot(@NotNull File destination) {
         try {
-            Texture texture = ((ShadersRenderer) this.mc.renderer).getWorldFramebufferColor();
-            texture.bind();
+            final @NotNull FrameBuffer frameBuffer = Objects.requireNonNull(((ShadersRenderer) this.mc.renderer).getWorldFrameBuffer());
+            Objects.requireNonNull(frameBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
 
             int w = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
             int h = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 8e708c319..4e53b667b 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -244,7 +244,7 @@ public class PacketHandlerClient extends PacketHandler {
         if (this.worldClientMP.dimension.id != packet.dimId) return;
         Weather currentWeather = packet.id == -1 ? null : Weathers.WEATHERS[packet.id];
         Weather newWeather = packet.newId == -1 ? null : Weathers.WEATHERS[packet.newId];
-        this.worldClientMP.weatherManager.overrideWeather(currentWeather, newWeather, packet.duration, packet.intensity, packet.power);
+        this.worldClientMP.getWeatherManager().overrideWeather(currentWeather, newWeather, packet.duration, packet.intensity, packet.power);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 652a073fa..f4e5af88c 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -11,16 +11,7 @@ import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
-import net.minecraft.client.option.enums.CloudQuality;
-import net.minecraft.client.option.enums.Colorblindness;
-import net.minecraft.client.option.enums.DescriptionPromptEnum;
-import net.minecraft.client.option.enums.LeavesQuality;
-import net.minecraft.client.option.enums.LightmapStyle;
-import net.minecraft.client.option.enums.MipmapType;
-import net.minecraft.client.option.enums.ParticlesQuality;
-import net.minecraft.client.option.enums.RenderScale;
-import net.minecraft.client.option.enums.TextOutlineQuality;
-import net.minecraft.client.option.enums.TextureAnimation;
+import net.minecraft.client.option.enums.*;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.world.chunk.provider.SelectedProvider;
 import net.minecraft.core.entity.player.Player;
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/MSAA.java b/game/client/src/main/java/net/minecraft/client/option/enums/MSAA.java
new file mode 100644
index 000000000..f741339fd
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/MSAA.java
@@ -0,0 +1,14 @@
+package net.minecraft.client.option.enums;
+
+public enum MSAA {
+    OFF(0),
+    X2(2),
+    X4(4),
+    X8(8);
+
+    public final int samples;
+
+    MSAA(final int samples) {
+        this.samples = samples;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 717428414..0caf8c889 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -40,7 +40,7 @@ public class FogManager {
         this.fogBrightnessOld = this.fogBrightness;
 
         float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
-        fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
+        fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower()));
 
         float brightnessAtCamera = this.mc.currentWorld.getLightBrightness(this.mc.activeCamera.getTilePos());
         if (this.mc.fullbright) brightnessAtCamera = 1.0f;
@@ -83,7 +83,7 @@ public class FogManager {
                 float maxFogDistance = GameSettings.RENDER_DISTANCE.highest * 16;
 
                 float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
-                fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
+                fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower()));
 
                 if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
 
@@ -128,7 +128,7 @@ public class FogManager {
         this.fogBlue += (bSky - this.fogBlue) * renderDistanceScale;
 
         if (world.getCurrentWeather() != null) {
-            float[] out = world.getCurrentWeather().modifyFogColor(this.fogRed, this.fogGreen, this.fogBlue, world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
+            float[] out = world.getCurrentWeather().modifyFogColor(this.fogRed, this.fogGreen, this.fogBlue, world.getWeatherManager().getWeatherIntensity() * world.getWeatherManager().getWeatherPower());
             this.fogRed = out[0];
             this.fogGreen = out[1];
             this.fogBlue = out[2];
diff --git a/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java b/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
index bdfdae08f..7293db94b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
@@ -4,7 +4,7 @@ import static org.lwjgl.opengl.ARBFramebufferObject.*;
 
 public class FrameBuffer {
 	
-	private int id;
+	protected int id;
 	
 	public boolean generate() {
 		if(isGenerated()) {
@@ -26,6 +26,7 @@ public class FrameBuffer {
 		
 		glDeleteFramebuffers(id);
 		id = 0;
+
 		return true;
 	}
 	
diff --git a/game/client/src/main/java/net/minecraft/client/render/FrameBufferMultisampled.java b/game/client/src/main/java/net/minecraft/client/render/FrameBufferMultisampled.java
new file mode 100644
index 000000000..0274ec8ae
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/FrameBufferMultisampled.java
@@ -0,0 +1,63 @@
+package net.minecraft.client.render;
+
+import org.lwjgl.opengl.GL41;
+
+public class FrameBufferMultisampled extends FrameBuffer {
+    private int blitId;
+
+    @Override
+    public boolean generate() {
+        if (!super.generate()) {
+            return false;
+        }
+
+        this.blitId = GL41.glGenFramebuffers();
+        if(!this.isGenerated()) {
+            throw new RuntimeException("Framebuffer not created!");
+        }
+
+        return true;
+    }
+
+    @Override
+    public boolean delete() {
+        if (!super.delete()) {
+            return false;
+        }
+
+        GL41.glDeleteFramebuffers(this.blitId);
+        this.blitId = 0;
+
+        return true;
+    }
+
+    public boolean blit(final int width, final int height) {
+        if (!this.isGenerated()) {
+            return false;
+        }
+
+        GL41.glBindFramebuffer(GL41.GL_READ_FRAMEBUFFER, this.id);
+        GL41.glBindFramebuffer(GL41.GL_DRAW_FRAMEBUFFER, this.blitId);
+        GL41.glBlitFramebuffer(0, 0, width, height, 0, 0, width, height, GL41.GL_COLOR_BUFFER_BIT, GL41.GL_NEAREST);
+
+        GL41.glBindFramebuffer(GL41.GL_READ_FRAMEBUFFER, 0);
+        GL41.glBindFramebuffer(GL41.GL_DRAW_FRAMEBUFFER, 0);
+
+        return true;
+    }
+
+    public boolean bindBlit() {
+        if (!this.isGenerated()) {
+            return false;
+        }
+
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, this.blitId);
+
+        return true;
+    }
+
+    @Override
+    public boolean isGenerated() {
+        return super.isGenerated() && this.blitId != 0;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index 3f7e15b42..758fdc02f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
@@ -46,7 +47,7 @@ final public class LightingCache {
     }
 
     private float calcBrightness(final @NotNull TilePos tilePos) {
-        if (this.block.emission >= 15 || !this.mc.isAmbientOcclusionEnabled()) {
+        if (this.block.emission >= 15 || !GameSettings.AMBIENT_OCCLUSION.value) {
             return 1.0f;
         }
         return 1.0f - this.access.getBlockType(tilePos).getAmbientOcclusionStrength(this.access, tilePos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 5ba74f788..ecae3acf0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -128,7 +128,7 @@ public class PostProcessingManager {
         // Perform weather effects
         final Weather activeWeather = this.mc.currentWorld.getCurrentWeather();
         if (activeWeather != null) {
-            final float intensity = this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherIntensity();
+            final float intensity = this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherIntensity();
             if (activeWeather == Weathers.OVERWORLD_SNOW || activeWeather == Weathers.OVERWORLD_WINTER_SNOW) {
                 this.current.contrast += -0.125f * intensity * surfaceness;
                 this.current.saturation += -0.25f * intensity * surfaceness;
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 36e126c8b..d7046525b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -745,7 +745,7 @@ public class RenderGlobal
         GLRenderer.setDepthMask(false);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
-        float sunAlpha = 1.0F - (this.world.getCurrentWeather() != null && this.world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (this.world.weatherManager.getWeatherIntensity() * this.world.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        float sunAlpha = 1.0F - (this.world.getCurrentWeather() != null && this.world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (this.world.getWeatherManager().getWeatherIntensity() * this.world.getWeatherManager().getWeatherPower()) * 1.5f : 0.0f);
 
         float x = 0.0F;
         float y = 0.0F;
@@ -792,7 +792,7 @@ public class RenderGlobal
             Weather[] blocked = this.world.getBlockBiome(new TilePos(this.mc.thePlayer)).blockedWeathers;
             boolean isWeatherBlocked = false;
             for (Weather w : blocked) {
-                if (w.equals(this.world.weatherManager.getLastWeather())) {
+                if (w.equals(this.world.getWeatherManager().getLastWeather())) {
                     isWeatherBlocked = true;
                     break;
                 }
@@ -1190,7 +1190,7 @@ public class RenderGlobal
             GLRenderer.pushFrame();
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-            float w = this.mc.getOutlineWidth();
+            float w = GameSettings.BLOCK_OUTLINE_WIDTH.get();
             GLRenderer.setColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
             GLRenderer.setLineWidth(org.joml.Math.max(4.0f * w * 2.0f, 1.0f));
             GLRenderer.setShader(Shaders.LINES);
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 96bf0b895..61f3bbb40 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -735,7 +735,7 @@ public class WorldRenderer {
         Weather weather = this.mc.currentWorld.getCurrentWeather();
         if (!(weather instanceof IPrecipitation precipitation) || !precipitation.spawnRainParticles()) return;
 
-        float f = this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower();
+        float f = this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower();
 
         if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED) {
             f /= 2.0F;
@@ -788,9 +788,9 @@ public class WorldRenderer {
         if (l > 0 && this.random.nextInt(3) < this.rainSoundCounter++) {
             this.rainSoundCounter = 0;
             if (d1 > this.mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor(this.mc.activeCamera.getX()), MathHelper.floor(this.mc.activeCamera.getZ())) > MathHelper.floor(this.mc.activeCamera.getY())) {
-                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower() * 0.5f, 0.5F);
+                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower() * 0.5f, 0.5F);
             } else {
-                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.2F * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower() * 0.5f, 1.0F);
+                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.2F * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower() * 0.5f, 1.0F);
             }
         }
     }
@@ -813,7 +813,7 @@ public class WorldRenderer {
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 //        glAlphaFunc(516, 0.01F);
 
-        this.mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.weatherManager.getWeatherPower(), world.weatherManager.getWeatherIntensity())).bind();
+        this.mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.getWeatherManager().getWeatherPower(), world.getWeatherManager().getWeatherIntensity())).bind();
 
         double nextPosX = this.mc.activeCamera.getX(partialTick);
         double nextPosY = this.mc.activeCamera.getY(partialTick);
@@ -866,7 +866,7 @@ public class WorldRenderer {
                         } else {
                             brightness = world.getLightBrightness(queryPos.set(x, i3, z));
                         }
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.getWeatherManager().getWeatherIntensity() * world.getWeatherManager().getWeatherPower());
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
                         tessellator.addVertexWithUV(x, k3, (double) z + 0.5D, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV(x + 1, k3, (double) z + 0.5D, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
@@ -917,7 +917,7 @@ public class WorldRenderer {
                             brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
                         }
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.getWeatherManager().getWeatherIntensity() - 0.1f) * world.getWeatherManager().getWeatherPower());
                         tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F + f4 * f2);
@@ -965,7 +965,7 @@ public class WorldRenderer {
                         } else {
                             brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
                         }
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.getWeatherManager().getWeatherIntensity() - 0.1f) * world.getWeatherManager().getWeatherPower());
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
                         tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F - vOffset * f2);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 3a8eb749c..f29dc48b6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.LightIndexHelper;
@@ -247,7 +248,7 @@ public final class RenderBlocks {
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
                               int lefX, int lefY, int lefZ, float lefP, float rigP) {
-        boolean ao = this.mc.isAmbientOcclusionEnabled() && block.emission == 0;
+        boolean ao = GameSettings.AMBIENT_OCCLUSION.value && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
         if (ao) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index 5766e384f..e0557a2bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -98,7 +98,7 @@ public class Colorizers {
 			return;
 		}
 		
-		Season currentSeason = world.seasonManager.getCurrentSeason();
+		Season currentSeason = world.getSeasonManager().getCurrentSeason();
 		Dimension currentDimension = world.dimension;
 		float seasonProgress = getSeasonProgress(world);
 		
@@ -243,7 +243,7 @@ public class Colorizers {
 	}
 	
 	public static float getSeasonProgress(World world) {
-		if(world.seasonManager instanceof SeasonManagerCycle seasonManager) {
+		if(world.getSeasonManager() instanceof SeasonManagerCycle seasonManager) {
             Season currentSeason = seasonManager.getCurrentSeason();
 			
 			int dayInSeason = seasonManager.getDayInSeason();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index ffc89c256..039dea3ca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -12,6 +12,7 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -161,7 +162,9 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
     }
 
     protected void renderSpecials(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z) {
-        if (Minecraft.getMinecraft().canRenderEntityLabel()) {
+        final @NotNull Minecraft mc = Minecraft.getMinecraft();
+
+        if (GameSettings.SHOW_DEBUG_SCREEN.value && mc.thePlayer != null && mc.thePlayer.getGamemode() == Gamemodes.CREATIVE) {
             renderLivingLabel(tessellator, entity, Integer.toString(entity.id), x, y, z, 64, false);
         } else if (!entity.nickname.isEmpty()) {
             renderLivingLabel(tessellator, entity, entity.getDisplayName(), x, y, z, 64, true);
